000100170905**free
000201170905ctl-opt pgminfo(*pcml:*module:*dclcase)  DFTNAME(CLIENTR);
000300170907// ********************************************************************
000301170907//                                                                    *
000302170907//                   IBM Web Services Client for ILE                  *
000303170907//                                                                    *
000304170907//   FILE NAME:      client.RPGLE                                     *
000305170907//                                                                    *
000306170907//   DESCRIPTION:    Source to do REST request using transport APIs   *
000307170907//                                                                    *
000308170907// ********************************************************************
000309170907//  LICENSE AND DISCLAIMER                                            *
000310170907//  ----------------------                                            *
000311170907//  This material contains IBM copyrighted sample programming source  *
000312170907//  code ( Sample Code ).                                             *
000313170907//  IBM grants you a nonexclusive license to compile, link, execute,  *
000314170907//  display, reproduce, distribute and prepare derivative works of    *
000315170907//  this Sample Code.  The Sample Code has not been thoroughly        *
000316170907//  tested under all conditions.  IBM, therefore, does not guarantee  *
000317170907//  or imply its reliability, serviceability, or function. IBM        *
000318170907//  provides no program services for the Sample Code.                 *
000319170907//                                                                    *
000320170907//  All Sample Code contained herein is provided to you "AS IS"       *
000321170907//  without any warranties of any kind. THE IMPLIED WARRANTIES OF     *
000322170907//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND             *
000323170907//  NON-INFRINGMENT ARE EXPRESSLY DISCLAIMED.                         *
000324170907//  SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED          *
000325170907//  WARRANTIES, SO THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO  *
000326170907//  EVENT WILL IBM BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT,   *
000327170907//  SPECIAL OR OTHER CONSEQUENTIAL DAMAGES FOR ANY USE OF THE SAMPLE  *
000328170907//  CODE INCLUDING, WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS    *
000329170907//  INTERRUPTION, LOSS OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION  *
000330170907//  HANDLING SYSTEM OR OTHERWISE, EVEN IF WE ARE EXPRESSLY ADVISED OF *
000331170907//  THE POSSIBILITY OF SUCH DAMAGES.                                  *
000332170907//                                                                    *
000333170907//   <START_COPYRIGHT>                                                *
000334170907//                                                                    *
000335170907//   Licensed Materials - Property of IBM                             *
000336170907//                                                                    *
000337170907//   5770-SS1                                                         *
000338170907//                                                                    *
000339170907//   (c) Copyright IBM Corp. 2016, 2016                               *
000340170907//   All Rights Reserved                                              *
000341170907//                                                                    *
000342170907//   U.S. Government Users Restricted Rights - use,                   *
000343170907//   duplication or disclosure restricted by GSA                      *
000344170907//   ADP Schedule Contract with IBM Corp.                             *
000345170907//                                                                    *
000346170907//   Status: Version 1 Release 0                                      *
000347170907//   <END_COPYRIGHT>                                                  *
000348170907//                                                                    *
000349170907// ********************************************************************
000350170907
005400170905/COPY /QIBM/ProdData/OS/WebServices/V1/client/include/Axis.rpgleinc
005500170905
005600170905DCL-S rc         INT(10);
005700170905DCL-S tHandle    POINTER;
005800170905
005900170905DCL-S uri        CHAR(200);
006000170905DCL-S response   CHAR(32768);
006100170905DCL-S request    CHAR(32768);
006200170905DCL-S propBuf    CHAR(100);
006300170905DCL-S propBuf2   CHAR(100);
006400170905
006500170905// --------------------------------------------------------------------
006600170905//  Web service logic. The code will attempt to invoke a Web service.
006700170905// --------------------------------------------------------------------
006800170905
006900170905// Uncomment to enable trace
007000170905axiscAxisStartTrace('/tmp/axistransport.log': *NULL);
007100170905
007200170905// Set URI in order to delete student
007300170906uri = 'http://rchpw720.rchland.ibm.com:10065/web/services/students/823M934LA'+ x'00';
007400170905
007500170905// Create HTTP transport handle.
007600170905tHandle = axiscTransportCreate(uri:AXISC_PROTOCOL_HTTP11);
007700170905if (tHandle = *NULL);
007800170905  PRINT ('TransportCreate() failed');
007900170905  return;
008000170905endif;
008100170905
008200170905// Delete student registration, ID is part of URI
008300170905PRINT ('==Deleting student registration record');
008400170905
008500170905propBuf = 'DELETE' + X'00';
008600170905axiscTransportSetProperty(tHandle: AXISC_PROPERTY_HTTP_METHOD: %addr(propBuf));
008700170905flushAndReceiveData();
008800170905
008900170905// Now create a new student registration
009000170905PRINT ('==Creating student registration record');
009100170905
009200170906uri = 'http://rchpw720.rchland.ibm.com:10065/web/services/students'+ x'00';
009300170907axiscTransportReset(tHandle:uri); //Reset the transport object to its initial state
009400170905
009500170905propBuf  = 'Content-type' + X'00';
009600170905propBuf2 = 'application/json' + X'00';
009700170905axiscTransportSetProperty(tHandle: AXISC_PROPERTY_HTTP_HEADER:
009800170905                          %addr(propBuf):%addr(propBuf2));
009900170905
010000170905propBuf = 'POST' + X'00';
010100170905axiscTransportSetProperty(tHandle: AXISC_PROPERTY_HTTP_METHOD: %addr(propBuf));
010200170905
010300170906request = '{"studentID":"123456789","firstName":'
010400170906        + '"New","lastName":"Rec","gender":"Male"}';
010500170905
010600170905rc = axiscTransportSend(tHandle: %ADDR(request): %len(%trim(request)): 0);
010700170905if (rc = -1);
010800170905  checkError ('TransportSend()');
010900170905else;
011000170905  flushAndReceiveData();
011100170905endif;
011200170905
011203170907
011300170905// Now retrieve all student records
011301170907axiscTransportReset(tHandle:uri);  // Reset the transport object to its initial state
011400170905PRINT ('==Retrieving student registration records');
011500170905propBuf = 'GET' + X'00';
011600170905axiscTransportSetProperty(tHandle: AXISC_PROPERTY_HTTP_METHOD: %addr(propBuf));
011700170905flushAndReceiveData();
011800170905
011900170905// Cleanup handle.
012000170905axiscTransportDestroy(tHandle);
012100170905
012200170905*INLR=*ON;
012300170905
012400170905
012500170905// =========================================
012600170905// Print to standard out
012700170905// =========================================
012800170905DCL-PROC PRINT ;
012900170905  dcl-pi *n;
013000170905    msg varchar(5000) const;
013100170905  end-pi;
013200170905
013300170905  dcl-pr printf extproc(*dclcase);
013400170905     template pointer value options(*string);
013500170905     dummy int(10) value options(*nopass);
013600170905  end-pr;
013700170905
013800170905  dcl-c NEWLINE CONST(x'15');
013900170905
014000170905  printf(%TRIM(msg) + NEWLINE);
014100170905END-PROC PRINT;
014200170905
014300170905// =========================================
014400170905// Handle error
014500170905// =========================================
014600170905DCL-PROC checkError ;
014700170905  dcl-pi *n;
014800170905    msg varchar(5000) const;
014900170905  end-pi;
015000170905
015100170905  DCL-S axisCode   INT(10);
015200170905  DCL-S statusCode POINTER;
015300170905  DCL-S rc         INT(10);
015400170905
015500170905  axisCode = axiscTransportGetLastErrorCode(tHandle);
015600170905  PRINT (msg + ' call failed: ' +
015700170905         %CHAR(axisCode) + ':' +
015800170905         %STR(axiscTransportGetLastError(tHandle)));
015900170905
016000170905  if (axisCode = EXC_TRANSPORT_HTTP_EXCEPTION);
016100170905    rc = axiscTransportGetProperty(tHandle:
016200170905            AXISC_PROPERTY_HTTP_STATUS_CODE: %ADDR(statusCode));
016300170905    PRINT ('HTTP Status code: ' + %STR(statusCode));
016400170905  endif;
016500170905END-PROC checkError;
016600170905
016700170905// =========================================
016800170905// Flush and Receive data
016900170905// =========================================
017000170905DCL-PROC flushAndReceiveData;
017100170905  dcl-pi *n;
017200170905  end-pi;
017300170905
017400170905  DCL-S header     POINTER;
017500170905  DCL-S property   CHAR(100);
017600170905  DCL-S bytesRead  INT(10) inz(0);
017700170905
017800170905  clear response;
017900170905  clear header;
018000170905
018100170905  // Flush data so request is sent
018200170905  rc = axiscTransportFlush(tHandle);
018300170905  if (rc = -1);
018400170905    checkError ('TransportFlush()');
018500170905    return;
018600170905  endif;
018700170905
018800170905  // Receive data and print out data and response to stdout
018900170905  rc = axiscTransportReceive(tHandle: %ADDR(response): %SIZE(response): 0);
019000170905  if (rc = 0);
019100170905    PRINT ('No data to read');
019200170905  else;
019300170905    dow rc > 0 AND bytesRead < %SIZE(response);
019400170905      bytesRead = bytesRead + rc;
019500170905      rc = axiscTransportReceive(tHandle:
019600170905                                 %ADDR(response)+bytesRead:
019700170905                                 %SIZE(response)-bytesRead:
019800170905                                 0);
019900170905    enddo;
020000170905  endif;
020100170905
020200170905  if (rc = -1);
020300170905    checkError ('TransportReceive()');
020400170905  elseif (bytesRead  > 0);
020500170905    PRINT ('Bytes read: ' + %CHAR(bytesRead));
020600170905    PRINT ('Data: ' + response);
020700170905  endif;
020800170905
020900170905  if (rc > -1);
021000170905    rc = axiscTransportGetProperty(tHandle:
021100170905                                   AXISC_PROPERTY_HTTP_STATUS_CODE:
021200170905                                   %addr(header));
021300170905    if (rc = -1);
021400170905      checkError ('TransportGetProperty()');
021500170905    else;
021600170905      PRINT ('HTTP status code: ' + %str(header));
021700170905    endif;
021800170905  endif;
021900170905
022000170905END-PROC flushAndReceiveData;
022100170905
